local _, private = ...
	private.defaults.mmsliderSetScale = {
		minimapScale = 0.86,
	}	
	
-- Minimap Slider:
local MMSlider = CreateFrame("Slider", "MMSlider", DejaViewPanel, "OptionsSliderTemplate")
	MMSlider:RegisterEvent("PLAYER_LOGIN")
	MMSlider:RegisterEvent("PLAYER_ENTERING_WORLD")
	MMSlider:RegisterEvent("ADDON_LOADED")
	MMSlider:SetPoint("CENTER", DejaViewPanel, "CENTER", 0, 0)
	MMSlider:SetWidth(200)
	MMSlider:SetHeight(10)
	MMSlider:SetOrientation('HORIZONTAL')
	MMSlider:SetMinMaxValues(0.50, 3.0)
	MMSlider.minValue, MMSlider.maxValue = MMSlider:GetMinMaxValues() 
	MMSlider:SetValueStep(0.05)
	MMSlider:SetObeyStepOnDrag(true)

	MMSlider.tooltipText = 'Scale the minimap in increments or decrements of 5' --Creates a tooltip on mouseover.

	getglobal(MMSlider:GetName() .. 'Low'):SetText(MMSlider.minValue); --Sets the left-side slider text (default is "Low").
	getglobal(MMSlider:GetName() .. 'High'):SetText(MMSlider.maxValue); --Sets the right-side slider text (default is "High").

	MMSlider:Show()
			
	MMSlider:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local slideValue = private.db.mmsliderSetScale.minimapScale
			self:SetValue(slideValue)
			Minimap:SetScale(slideValue)
			dvminimapframe:SetScale(slideValue)

			getglobal(MMSlider:GetName() .. 'Text'):SetFormattedText("Minimap Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
		end
	end)

	MMSlider:SetScript("OnValueChanged", function(self, value) 
	local slideValue = MMSlider:GetValue()
		Minimap:SetScale(slideValue)
		dvminimapframe:SetScale(slideValue)
					
		getglobal(MMSlider:GetName() .. 'Text'):SetFormattedText("Minimap Scale = (%.2f)", (slideValue)); --Sets the "title" text (top-centre of slider).
		private.db.mmsliderSetScale.minimapScale = slideValue
	end)	

local _, private = ...
	private.defaults.dvminimapframeSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "UIParent", 
		relativePoint = "BOTTOMRIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	
-- DVMinimapFrame
local dvminimapframe=CreateFrame("Frame", "dvminimapframe", dvlockcheckframe)
	dvminimapframe:RegisterEvent("PLAYER_LOGIN")
	dvminimapframe:SetFrameStrata("HIGH")
	dvminimapframe:SetClampedToScreen(true)
	dvminimapframe:SetMovable(true)
	dvminimapframe:EnableMouse(true)
	dvminimapframe:RegisterForDrag("LeftButton")
	dvminimapframe:SetWidth(120)
	dvminimapframe:SetHeight(120)
	dvminimapframe:Show()
	
	dvminimapframe:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local slideValue = private.db.mmsliderSetScale
			self:SetScale(slideValue.minimapScale)	

		local point = private.db.dvminimapframeSetPoints
			self:ClearAllPoints()		
			self:SetPoint(
				point.point, 
				point.relativeTo, 
				point.relativePoint, 
				point.xOffset, 
				point.yOffset)
		end
	end)

	dvminimapframe:SetScript("OnDragStart", dvminimapframe.StartMoving) 
	
	dvminimapframe:SetScript("OnDragStop", function(self) 
		self:StopMovingOrSizing() 
		self:SetUserPlaced(false) 
		
		point, relativeTo, relativePoint, xOfs, yOfs = self:GetPoint(1)
			if ( relativeTo ) then
				relativeTo = relativeTo:GetName();
			else
				relativeTo = self:GetParent():GetName();
			end
	
		-- These are debugging messages for the frame points
		-- Un-comment them to help debug
		-- DEFAULT_CHAT_FRAME:AddMessage(point)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativeTo)
		-- DEFAULT_CHAT_FRAME:AddMessage(relativePoint)
		-- DEFAULT_CHAT_FRAME:AddMessage(xOfs)
		-- DEFAULT_CHAT_FRAME:AddMessage(yOfs)

		private.db.dvminimapframeSetPoints.point = point
		private.db.dvminimapframeSetPoints.relativeTo = relativeTo
		private.db.dvminimapframeSetPoints.relativePoint = relativePoint
		private.db.dvminimapframeSetPoints.xOffset = xOfs
		private.db.dvminimapframeSetPoints.yOffset = yOfs			
	end)
	
local dvminimapframeFS = dvminimapframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local dvminimapFS = dvminimapframe:CreateFontString("FontString","OVERLAY","GameTooltipText")

	dvminimapFS:SetPoint("CENTER",dvminimapframe,"CENTER",0,0)
	dvminimapFS:SetFont("Fonts\\FRIZQT__.TTF", 10, "THINOUTLINE")
	dvminimapFS:SetText("MiniMap");
	dvminimapFS:SetTextColor(1, 1, 1);
	
local t=dvminimapframe:CreateTexture(nil,"ARTWORK")
	t:SetAllPoints(dvminimapframe)
	t:SetColorTexture(0, 192, 255, 0.7)
	
	Minimap:SetPoint("BOTTOMRIGHT", dvminimapframe, "BOTTOMRIGHT", 0, 0)
	
	Minimap:SetScript("OnEvent", function(self, event, arg1)
		if event == "PLAYER_LOGIN" then
		local slideValue = private.db.mmsliderSetScale
			self:SetScale(slideValue.minimapScale)	
		end
	end)
	
-- Deja Minimap

local _, private = ...
	private.defaults.minimapSetPoints = {
		point = "BOTTOMRIGHT", 
		relativeTo = "UIParent", 
		relativePoint = "BOTTOMRIGHT", 
		xOffset = 0, 
		yOffset = 0,
	}	
	
-- Minimap

--Hide Minimap Frames
	MinimapBorder:Hide()
	MinimapBorderTop:Hide()
	MinimapZoomIn:Hide()
	MinimapZoomOut:Hide()
	MinimapNorthTag:Hide()
	MiniMapTracking:SetAlpha(0)

--Hide Minimap Clock
local mm = CreateFrame("Frame", "DejaMinimapFrame")

	mm:RegisterEvent("PLAYER_LOGIN")
	mm:RegisterEvent("PLAYER_ENTERING_WORLD")
	mm:RegisterEvent("ADDON_LOADED")
	mm:RegisterEvent("PET_BATTLE_OVER")
	mm:RegisterEvent("UPDATE_INSTANCE_INFO")

local function eventHandler(self, event, ...)
	for i = 1, 1 do
		if TimeManagerClockButton then
			TimeManagerClockButton:SetAlpha(0)
		end
	end
end

mm:SetScript("OnEvent",eventHandler)

-- Make Minimap Movable
	Minimap:RegisterEvent("PLAYER_LOGIN")
	Minimap:SetParent("UIParent")
	Minimap:SetFrameStrata("MEDIUM")
	Minimap:SetFrameLevel("5")
	Minimap:SetClampedToScreen(true)
	Minimap:SetMovable(true)
	Minimap:EnableMouse(true)
	Minimap:RegisterForDrag("LeftButton")
	Minimap:SetMaskTexture('Interface\\ChatFrame\\ChatFrameBackground')
	Minimap:EnableMouseWheel(true)
	Minimap:SetPoint("BOTTOMRIGHT", dvminimapframe, "BOTTOMRIGHT", 0, 0)

	
	Minimap:SetScript("OnMouseWheel", function(mp, input)
	local zoom = Minimap:GetZoom()
		if input > 0 and zoom < 5 then
			mp:SetZoom(zoom +1)
		elseif input < 0 and zoom > 0 then
			mp:SetZoom(zoom -1)
		end
	end)

-- Move Minimap Icons
	MiniMapTracking:ClearAllPoints()
	MiniMapTracking:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	QueueStatusMinimapButton:ClearAllPoints()
	QueueStatusMinimapButton:SetPoint("CENTER", Minimap, "LEFT", 0, 0)

	MiniMapInstanceDifficulty_AdjustPosition = function() end
	MiniMapInstanceDifficulty:SetParent(UIParent)
	MiniMapInstanceDifficulty:SetScale(0.5)
	MiniMapInstanceDifficulty:ClearAllPoints()
	MiniMapInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	GuildInstanceDifficulty_AdjustPosition = function() end
	GuildInstanceDifficulty:SetParent(UIParent)
	GuildInstanceDifficulty:SetScale(0.5)
	GuildInstanceDifficulty:ClearAllPoints()
	GuildInstanceDifficulty:SetPoint("TOPLEFT", Minimap, "TOPLEFT", 0, 0)

	MiniMapMailBorder:SetAlpha(0)
	MiniMapMailFrame:SetScale(1.25)
	MiniMapMailFrame:ClearAllPoints()
	MiniMapMailFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 7, 5)

	GameTimeFrame:SetAlpha(0)
	GameTimeFrame:ClearAllPoints()
	GameTimeFrame:SetPoint("TOPRIGHT", Minimap, "TOPRIGHT", 0, 0)

	MiniMapWorldMapButton:SetScale(1.5)
	MiniMapWorldMapButton:SetAlpha(0)
	MiniMapWorldMapButton:ClearAllPoints()
	MiniMapWorldMapButton:SetPoint("TOP", Minimap, "TOP", 0, 10)

	MiniMapRecordingBorder:SetAlpha(0)
	MiniMapRecordingButton:ClearAllPoints()
	MiniMapRecordingButton:SetPoint("BOTTOMLEFT", Minimap, "BOTTOMLEFT", 0, 0)
	
	MinimapBackdrop:Hide()

--Zone Text
local zoneframe = CreateFrame("Frame", nil, UIParent)
	zoneframe:SetFrameStrata("MEDIUM")
	zoneframe:SetFrameLevel("9")
	zoneframe:SetWidth(100)
	zoneframe:SetHeight(26)
	zoneframe:SetPoint("TOP", Minimap, "TOP")
	zoneframe:Show()

	MinimapZoneTextButton:ClearAllPoints()
	MinimapZoneTextButton:SetPoint("TOP", zoneframe, "TOP", 0, 0)
	MinimapZoneTextButton:SetFrameStrata("MEDIUM")
	MinimapZoneTextButton:SetFrameLevel("9")
	
-- Create New Minimap Clock
local use24hformat = false

local mmclock = CreateFrame("Frame", nil, UIParent)
	mmclock:RegisterEvent("PLAYER_LOGIN")
	mmclock:RegisterEvent("PLAYER_ENTERING_WORLD")
	mmclock:RegisterEvent("ADDON_LOADED")
	mmclock:RegisterEvent("PLAYER_REGEN_DISABLED")
	mmclock:RegisterEvent("PLAYER_REGEN_ENABLED")
	mmclock:RegisterEvent("UNIT_COMBAT")
	mmclock:RegisterEvent("PET_BATTLE_OVER")
	mmclock:RegisterEvent("PET_BATTLE_OPENING_START")
	mmclock:SetFrameStrata("MEDIUM")
	mmclock:SetFrameLevel("9")
	mmclock:SetWidth(100)
	mmclock:SetHeight(26)
	mmclock:SetPoint("BOTTOM", Minimap, "BOTTOM", 0, 0)
	mmclock:Show()

local clockFS = mmclock:CreateFontString("FontString","OVERLAY","GameTooltipText")

	clockFS:SetPoint("BOTTOM",mmclock,"BOTTOM",0,0)

local elapsed = 0
	mmclock:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   MinimapClockRefresh()
		   elapsed = 0
	   end
end)

	mmclock:SetScript("OnEvent", function()
		clockFS:SetTextColor(1, 1, 1);
		MinimapClockRefresh()
	end)
	
function MinimapClockRefresh()
	if use24hformat then
		clockFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		clockFS:SetText(date("%H:%M"))
	else
		clockFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		clockFS:SetText(("%d:%s"):format(tonumber(date("%I")),((date("%M%p")))))
	end
end

-- Minimap Coordinates
local coordframe = CreateFrame("Frame", nil, UIParent)
	coordframe:SetFrameStrata("MEDIUM")
	coordframe:SetFrameLevel("9")
	coordframe:SetWidth(100)
	coordframe:SetHeight(26)
	coordframe:SetPoint("TOP", MinimapZoneTextButton, "BOTTOM", 0, 0)
	coordframe:Show()

local elapsed = 0
local coordframeFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
local coordFS = coordframe:CreateFontString("FontString","OVERLAY","GameTooltipText")
function coordRefresh()
	local posX, posY = GetPlayerMapPosition("player")
		coordFS:SetFont("Fonts\\FRIZQT__.TTF", 12, "THINOUTLINE")
		coordFS:SetFormattedText("%.1f, %.1f", posX*100, posY*100)
end

	coordFS:SetPoint("TOP",coordframe,"TOP",0,0)

	coordframe:SetScript("OnEvent", function()
		   coordFS:SetTextColor(1, 1, 1);
		   coordRefresh()
	end)
	
	coordframe:SetScript("OnUpdate", function(self, e)
	   elapsed = elapsed + e
	   if elapsed >= 1 then
		   coordRefresh()
		   elapsed = 0
	   end
	end)